unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, jpeg;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Image1: TImage;
    Image2: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  Tcircle = class //    
    oldx,oldy:integer; //   
    x,y:integer; //  
    r:integer; // 
    x1,y1:real; //    ,
    Gr:Tbitmap; //   
    DrawCanvas:Tcanvas; //     
    tagIndex:integer; //      
    visible:boolean; // 
  private
    first:boolean;
  public
    procedure steep; //   
    procedure Draw; //  
    constructor Create(cx,cy,cr:integer); //  
  end;

  const r:integer=1; //  
var
  Form1: TForm1;

  clr:Tcircle; //  
  clr2:Tcircle; //  

  Cicle:array of Tcircle; //    
  CicleCount:integer=0;

implementation

{$R *.dfm}

constructor Tcircle.Create(cx,cy,cr:integer); //   
begin
   first:=true;
   x:=cx;
   y:=cy;
   r:=cr;
   x1:=random(2)-1; //   
   y1:=random(2)-1;
   if x1=0 then x1:=0.5;
   if y1=0 then y1:=0.8;
   Gr:=Tbitmap.Create;
   Gr.Width:=r*2;
   Gr.Height:=r*2;
   visible:=true;
   //     
   CicleCount:=CicleCount+1;
   setlength(Cicle,CicleCount);
   Cicle[CicleCount-1]:=self;
   Cicle[CicleCount-1].tagIndex:=CicleCount-1;

end;


Procedure Tcircle.steep;
var i:integer;
begin

 for i:=0 to CicleCount-1 do
   if tagIndex<>i then
     if (Cicle[i]<>nil) and (Cicle[i].visible) then
      if (abs(Cicle[i].x-x)<r) and (abs(Cicle[i].y-y)<r) then begin


      Cicle[i].x1:=Cicle[i].x1*(-2.5);
      Cicle[i].y1:=Cicle[i].y1*(-1.5);
      //      
      Cicle[i].visible:=false;
      Cicle[i].x1:=x1;
      Cicle[i].y1:=y1;
      Cicle[i].x:=x+1;
      Cicle[i].y:=y+1;
      Cicle[i].r:=r;

      Gr:=Tbitmap.Create;
      Gr.Width:=r*2;
      Gr.Height:=r*2;

//      Cicle[i]:=Create(50,50,5);



      end;

 oldx:=x;
 oldy:=y;
 first:=false;
 if x<=(r*2) then x1:=1; //        
 if y<=(r*2) then y1:=1; //       
 if ((x+r*2)>=DrawCanvas.ClipRect.Right) then x1:=-1; //       
 if ((y+r*2)>=DrawCanvas.ClipRect.Bottom) then y1:=-1; //       
 x:=x+round(x1*r); //     
 y:=y+round(y1*r);
end;

procedure Tcircle.Draw;
begin
 if visible then begin

    Gr.Canvas.Brush.Style:=bssolid;
    Gr.Canvas.Brush.color:=clwhite;
    Gr.Canvas.Pen.Color:=clwhite;
    Gr.Canvas.Rectangle(Gr.Canvas.ClipRect);
    //    image2.canvas
    Gr.Canvas.CopyRect(rect(0,0,r*2,r*2),form1.Image2.Canvas,rect(oldx-r,oldy-r,oldx+r,oldy+r));

    //  

    DrawCanvas.Draw(oldx-r,oldy-r,gr); //   
    DrawCanvas.Ellipse(x-r,y-r,x+r,y+r); //  
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
randomize;
  clr:=Tcircle.Create(100,50,10);
  clr.DrawCanvas:=form1.Image1.Canvas;
  clr2:=Tcircle.Create(100,50,10);
  clr2.DrawCanvas:=form1.Image1.Canvas;




end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   clr.steep;
   clr.Draw;
   clr2.steep;
   clr2.Draw;
end;

end.
